Index: /XIOS3/trunk/src/config/node_type.conf
===================================================================
--- /XIOS3/trunk/src/config/node_type.conf	(revision 2407)
+++ /XIOS3/trunk/src/config/node_type.conf	(revision 2408)
@@ -124,4 +124,8 @@
 #endif //__XIOS_CExtractAxis__
 
+#ifdef __XIOS_CPoolNode__
+   DECLARE_NODE(PoolNode, pool)
+#endif //__XIOS_CPoolNode__
+
 #ifdef __XIOS_CContext__
    DECLARE_NODE_PAR(Context, context)
Index: /XIOS3/trunk/src/config/pool_attribute.conf
===================================================================
--- /XIOS3/trunk/src/config/pool_attribute.conf	(revision 2408)
+++ /XIOS3/trunk/src/config/pool_attribute.conf	(revision 2408)
@@ -0,0 +1,1 @@
+DECLARE_ATTRIBUTE(StdString, name)
Index: /XIOS3/trunk/src/group_factory_decl.cpp
===================================================================
--- /XIOS3/trunk/src/group_factory_decl.cpp	(revision 2407)
+++ /XIOS3/trunk/src/group_factory_decl.cpp	(revision 2408)
@@ -48,3 +48,5 @@
   macro(CReorderDomainGroup)
   macro(CExtractDomainGroup)
+  macro(CPoolNodeGroup)
+
 }
Index: /XIOS3/trunk/src/group_template_decl.cpp
===================================================================
--- /XIOS3/trunk/src/group_template_decl.cpp	(revision 2407)
+++ /XIOS3/trunk/src/group_template_decl.cpp	(revision 2408)
@@ -37,4 +37,5 @@
   macro(ReorderDomain)
   macro(ExtractDomain)
+  macro(PoolNode)
 
 }
Index: /XIOS3/trunk/src/node/node_enum.hpp
===================================================================
--- /XIOS3/trunk/src/node/node_enum.hpp	(revision 2407)
+++ /XIOS3/trunk/src/node/node_enum.hpp	(revision 2408)
@@ -42,5 +42,7 @@
          eReduceScalarToScalar,
          eReorderDomain,
-         eExtractDomain
+         eExtractDomain,
+         ePoolNode,gPoolNode,
+//         eService, gService
        } ENodeType;
 
Index: /XIOS3/trunk/src/node/node_type.hpp
===================================================================
--- /XIOS3/trunk/src/node/node_type.hpp	(revision 2407)
+++ /XIOS3/trunk/src/node/node_type.hpp	(revision 2408)
@@ -33,4 +33,5 @@
 #include "reorder_domain.hpp"
 #include "extract_domain.hpp"
+#include "pool_node.hpp"
 
 
Index: /XIOS3/trunk/src/node/pool_node.cpp
===================================================================
--- /XIOS3/trunk/src/node/pool_node.cpp	(revision 2408)
+++ /XIOS3/trunk/src/node/pool_node.cpp	(revision 2408)
@@ -0,0 +1,23 @@
+#include "pool_node.hpp"
+
+namespace xios
+{
+  
+  CPoolNode::CPoolNode(void) : CObjectTemplate<CPoolNode>(), CPoolNodeAttributes()
+  { /* Ne rien faire de plus */ }
+
+  CPoolNode::CPoolNode(const StdString & id) : CObjectTemplate<CPoolNode>(id), CPoolNodeAttributes()
+  { /* Ne rien faire de plus */ }
+
+  CPoolNode::~CPoolNode(void)
+  { /* Ne rien faire de plus */ }
+
+
+  void CPoolNode::parse(xml::CXMLNode & node)
+  {
+    SuperClass::parse(node);
+  }
+
+
+}
+
Index: /XIOS3/trunk/src/node/pool_node.hpp
===================================================================
--- /XIOS3/trunk/src/node/pool_node.hpp	(revision 2408)
+++ /XIOS3/trunk/src/node/pool_node.hpp	(revision 2408)
@@ -0,0 +1,69 @@
+#ifndef __XIOS_CPoolNode__
+#define __XIOS_CPoolNode__
+
+#include "xios_spl.hpp"
+#include "attribute_enum.hpp"
+#include "attribute_enum_impl.hpp"
+#include "attribute_array.hpp"
+#include "declare_attribute.hpp"
+#include "object_template.hpp"
+#include "group_factory.hpp"
+#include "declare_group.hpp"
+
+
+namespace xios
+{
+  /// ////////////////////// DÃ©clarations ////////////////////// ///
+
+  class CPoolNodeGroup;
+  class CPoolNodeAttributes;
+  class CPoolNode;
+  ///--------------------------------------------------------------
+
+  // Declare/Define CVarAttribute
+  BEGIN_DECLARE_ATTRIBUTE_MAP(CPoolNode)
+#include "pool_attribute.conf"
+  END_DECLARE_ATTRIBUTE_MAP(CPoolNode)
+
+  ///--------------------------------------------------------------
+
+  class CPoolNode: public CObjectTemplate<CPoolNode>
+               , public CPoolNodeAttributes
+  {
+      friend class CCPoolNodeGroup;
+
+      /// typedef ///
+      typedef CObjectTemplate<CPoolNode>   SuperClass;
+      typedef CPoolNodeAttributes SuperClassAttribute;
+
+    public :
+
+      typedef CPoolNodeAttributes RelAttributes;
+      typedef CPoolNodeGroup      RelGroup;
+
+      /// Constructeurs ///
+      CPoolNode(void) ;
+      explicit CPoolNode(const StdString & id);
+      CPoolNode(const CPoolNode & var);       // Not implemented yet.
+      CPoolNode(const CPoolNode * const var); // Not implemented yet.
+    
+      /// Destructeur ///
+      virtual ~CPoolNode(void);
+     
+    public :
+      /// Accesseurs statiques ///
+      static StdString GetName(void)     { return StdString("pool"); }
+      static StdString GetDefName(void)  { return StdString("pool"); }
+      static ENodeType GetType(void)     { return ePoolNode; }
+    public:
+      virtual void parse(xml::CXMLNode & node);
+
+  }; // class CPoolNode
+  ///--------------------------------------------------------------
+
+  // Declare/Define CPoolNodeGroup and CPoolNodeDefinition
+  DECLARE_GROUP(CPoolNode);
+} // namespace xios
+
+#endif // __XIOS_CPoolNode__
+
Index: /XIOS3/trunk/src/object_factory_decl2.cpp
===================================================================
--- /XIOS3/trunk/src/object_factory_decl2.cpp	(revision 2407)
+++ /XIOS3/trunk/src/object_factory_decl2.cpp	(revision 2408)
@@ -21,4 +21,5 @@
   macro(CReorderDomain)
   macro(CExtractDomain)
+  macro(CPoolNode)
 }
 
Index: /XIOS3/trunk/src/object_factory_decl3.cpp
===================================================================
--- /XIOS3/trunk/src/object_factory_decl3.cpp	(revision 2407)
+++ /XIOS3/trunk/src/object_factory_decl3.cpp	(revision 2408)
@@ -18,4 +18,5 @@
   macro(CExtractAxisGroup)
   macro(CZoomDomainGroup)
+  macro(CPoolNodeGroup)
 }
 
Index: /XIOS3/trunk/src/object_template_decl.cpp
===================================================================
--- /XIOS3/trunk/src/object_template_decl.cpp	(revision 2407)
+++ /XIOS3/trunk/src/object_template_decl.cpp	(revision 2408)
@@ -36,4 +36,5 @@
   template class CObjectTemplate<CReorderDomain>;
   template class CObjectTemplate<CExtractDomain>;
+  template class CObjectTemplate<CPoolNode>;
   
   template class CObjectTemplate<CContextGroup>;
@@ -67,3 +68,5 @@
   template class CObjectTemplate<CReorderDomainGroup>;
   template class CObjectTemplate<CExtractDomainGroup>;
+  template class CObjectTemplate<CPoolNodeGroup>;
+
 }
Index: /XIOS3/trunk/src/type/type_util.hpp
===================================================================
--- /XIOS3/trunk/src/type/type_util.hpp	(revision 2407)
+++ /XIOS3/trunk/src/type/type_util.hpp	(revision 2408)
@@ -66,4 +66,6 @@
     class CExtractDomain;
     class CExtractDomainGroup;
+    class CPoolNode ;
+    class CPoolNodeGroup ;
      
   template <typename T> inline string getStrType(void);
@@ -150,4 +152,6 @@
   macro(CExtractDomain)
   macro(CExtractDomainGroup)
+  macro(CPoolNode)
+  macro(CPoolNodeGroup)
   
 #undef macro
Index: /XIOS3/trunk/src/xml_parser_decl.cpp
===================================================================
--- /XIOS3/trunk/src/xml_parser_decl.cpp	(revision 2407)
+++ /XIOS3/trunk/src/xml_parser_decl.cpp	(revision 2408)
@@ -42,4 +42,5 @@
     macro( ReorderDomain )
     macro( ExtractDomain )
+    macro( PoolNode )
   }
 }